---
title: MediaCapabilities.decodingInfo()
slug: Web/API/MediaCapabilities/decodingInfo
tags:
  - API
  - Audio
  - Experimental
  - Media Capabilities API
  - MediaCapabilities
  - Method
  - Reference
  - Video
  - decodingInfo()
---
<p>{{APIRef("MediaCapabilities")}}</p>

<p>The <strong><code>MediaCapabilities.decodingInfo()</code></strong> method, part of the <a href="/en-US/docs/Web/API/MediaCapabilities">Media Capabilities API</a>, returns a promise with the tested media configuration's <a href="/en-US/docs/Web/API/MediaCapabilities/MediaCapabilitiesInfo">mediaCapabilitiesInfo</a>; this contains the three Boolean properties <code>supported</code>, <code>smooth</code>, and <code>powerefficient</code>, which describe whether decoding the media described would be supported, smooth, and powerefficient.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">mediaCapabilities.decodingInfo(<em>MediaDecodingConfiguration</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>MediaDecodingConfiguration</dt>
 <dd>A valid {{domxref("MediaDecodingConfiguration")}} dictionary containing a valid media decoding <code>type</code> of <code>file</code> or <code>media-source</code> and a valid media configuration: either an {{domxref("AudioConfiguration")}} or a {{domxref("VideoConfiguration")}}.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} fulfilling with a {{domxref("MediaCapabilitiesInfo")}} interface containing three Boolean attributes:</p>

<ul>
 <li><code>supported</code></li>
 <li><code>smooth</code></li>
 <li><code>powerEfficient</code></li>
</ul>

<h3 id="Exceptions">Exceptions</h3>

<p>A <code>TypeError</code> is raised if the <code>MediaConfiguration</code> passed to the <code>decodingInfo()</code> method is invalid, either because the type is not video or audio, the <code>contentType</code> is not a valid codec MIME type, the media decoding configuration is not a valid value for the <a href="/en-US/docs/Web/API/MediaDecodingType">media decoding type</a>, or any other error in the media configuration passed to the method, including omitting values required in the <a href="/en-US/docs/Web/API/MediaDecodingConfiguration">media decoding configuration</a>.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">//Create media configuration to be tested
const mediaConfig = {
    type : 'file', // or 'media-source'
    audio : {<code class="language-js">
        contentType <span class="punctuation token">:</span> <span class="string token">"audio/ogg"</span><span class="punctuation token">,</span> <span class="comment token">// valid content type </span>
        channels <span class="punctuation token">:</span> <span class="number token">2</span><span class="punctuation token">,</span>     <span class="comment token">// audio channels used by the track</span>
        bitrate <span class="punctuation token">:</span> <span class="number token">132700</span><span class="punctuation token">,</span> <span class="comment token">// number of bits used to encode 1s of audio </span>
        samplerate <span class="punctuation token">:</span> <span class="number token">5200</span> <span class="comment token">// number of audio samples making up that 1s. </span>
     </code>},
};

// check support and performance
navigator.mediaCapabilities.decodingInfo(mediaConfig).then(result =&gt; {
    console.log('This configuration is ' +
        (result.supported ? '' : 'not ') + 'supported, ' +
        (result.smooth ? '' : 'not ') + 'smooth, and ' +
        (result.powerEfficient ? '' : 'not ') + 'power efficient.')
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Capabilities', '#dom-mediacapabilities-decodinginfo-configuration-configuration', 'decodingInfo()')}}</td>
   <td>{{Spec2('Media Capabilities')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaCapabilities.decodingInfo")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaDecodingConfiguration")}}</li>
 <li>{{domxref("VideoConfiguration")}}</li>
 <li>{{domxref("AudioConfiguration")}}</li>
 <li>{{domxref("MediaCapabilities.encodingInfo()")}}</li>
</ul>
